summaryrefslogtreecommitdiff
path: root/mail/pkg
diff options
context:
space:
mode:
authorKali Kaneko (leap communications) <kali@leap.se>2016-08-29 23:05:33 -0400
committerKali Kaneko (leap communications) <kali@leap.se>2016-08-29 23:05:33 -0400
commit43df4205af42fce5d097f70bb0345b69e9d16f1c (patch)
tree3850a0ed0748476b37e2850bbdc10d10aadfbbbd /mail/pkg
parentaa882b7a64f2c821c8e241a5ff725f27c64fc15f (diff)
parent8e4746835a1a053558ff06d4fd12b31167a80296 (diff)
Merge leap_mail into unified bitmask repo
Diffstat (limited to 'mail/pkg')
-rw-r--r--mail/pkg/__init__.py0
-rwxr-xr-xmail/pkg/generate_wheels.sh14
-rwxr-xr-xmail/pkg/pip_install_requirements.sh86
-rw-r--r--mail/pkg/requirements-dev.pip14
-rw-r--r--mail/pkg/requirements-latest.pip9
-rw-r--r--mail/pkg/requirements-leap.pip3
-rw-r--r--mail/pkg/requirements-testing.pip7
-rw-r--r--mail/pkg/requirements.pip4
-rwxr-xr-xmail/pkg/tools/get_authors.sh2
-rwxr-xr-xmail/pkg/tools/with_venvwrapper.sh16
-rw-r--r--mail/pkg/utils.py101
11 files changed, 256 insertions, 0 deletions
diff --git a/mail/pkg/__init__.py b/mail/pkg/__init__.py
new file mode 100644
index 0000000..e69de29
--- /dev/null
+++ b/mail/pkg/__init__.py
diff --git a/mail/pkg/generate_wheels.sh b/mail/pkg/generate_wheels.sh
new file mode 100755
index 0000000..6679d1d
--- /dev/null
+++ b/mail/pkg/generate_wheels.sh
@@ -0,0 +1,14 @@
+#!/bin/sh
+# Generate wheels for dependencies
+# For convenience, u1db and dirspec are allowed with insecure flags enabled.
+# Use at your own risk.
+
+if [ "$WHEELHOUSE" = "" ]; then
+ WHEELHOUSE=$HOME/wheelhouse
+fi
+
+pip wheel --wheel-dir $WHEELHOUSE pip
+pip wheel --wheel-dir $WHEELHOUSE -r pkg/requirements.pip
+if [ -f pkg/requirements-testing.pip ]; then
+ pip wheel --wheel-dir $WHEELHOUSE -r pkg/requirements-testing.pip
+fi
diff --git a/mail/pkg/pip_install_requirements.sh b/mail/pkg/pip_install_requirements.sh
new file mode 100755
index 0000000..57732e2
--- /dev/null
+++ b/mail/pkg/pip_install_requirements.sh
@@ -0,0 +1,86 @@
+#!/bin/bash
+# Update pip and install LEAP base/testing requirements.
+# For convenience, $insecure_packages are allowed with insecure flags enabled.
+# Use at your own risk.
+# See $usage for help
+
+insecure_packages=""
+leap_wheelhouse=https://lizard.leap.se/wheels
+
+show_help() {
+ usage="Usage: $0 [--testing] [--use-leap-wheels]\n --testing\t\tInstall dependencies from requirements-testing.pip\n
+\t\t\tOtherwise, it will install requirements.pip\n
+--use-leap-wheels\tUse wheels from leap.se"
+ echo -e $usage
+
+ exit 1
+}
+
+process_arguments() {
+ testing=false
+ use_leap_wheels=false
+
+ while [ "$#" -gt 0 ]; do
+ # From http://stackoverflow.com/a/31443098
+ case "$1" in
+ --help) show_help;;
+ --testing) testing=true; shift 1;;
+ --use-leap-wheels) use_leap_wheels=true; shift 1;;
+
+ -h) show_help;;
+ -*) echo "unknown option: $1" >&2; exit 1;;
+ esac
+ done
+}
+
+return_wheelhouse() {
+ if $use_leap_wheels ; then
+ WHEELHOUSE=$leap_wheelhouse
+ elif [ "$WHEELHOUSE" = "" ]; then
+ WHEELHOUSE=$HOME/wheelhouse
+ fi
+
+ # Tested with bash and zsh
+ if [[ $WHEELHOUSE != http* && ! -d "$WHEELHOUSE" ]]; then
+ mkdir $WHEELHOUSE
+ fi
+
+ echo "$WHEELHOUSE"
+}
+
+return_install_options() {
+ wheelhouse=`return_wheelhouse`
+ install_options="-U --find-links=$wheelhouse"
+ if $use_leap_wheels ; then
+ install_options="$install_options --trusted-host lizard.leap.se"
+ fi
+
+ echo $install_options
+}
+
+return_insecure_flags() {
+ for insecure_package in $insecure_packages; do
+ flags="$flags --allow-external $insecure_package --allow-unverified $insecure_package"
+ done
+
+ echo $flags
+}
+
+return_packages() {
+ if $testing ; then
+ packages="-r pkg/requirements-testing.pip"
+ else
+ packages="-r pkg/requirements.pip"
+ fi
+
+ echo $packages
+}
+
+process_arguments $@
+install_options=`return_install_options`
+insecure_flags=`return_insecure_flags`
+packages=`return_packages`
+
+pip install -U wheel
+pip install $install_options pip
+pip install $install_options $insecure_flags $packages
diff --git a/mail/pkg/requirements-dev.pip b/mail/pkg/requirements-dev.pip
new file mode 100644
index 0000000..4bd76f6
--- /dev/null
+++ b/mail/pkg/requirements-dev.pip
@@ -0,0 +1,14 @@
+# ---------------------------
+# -- external requirements --
+# -- during development --
+# ---------------------------
+#
+# For temporary work, you can point this to your developer repo.
+# consolidated changes will be pushed to pypi and then added
+# to the main requirements.pip
+#
+# NOTE: you have to run pip install -r pkg/requirements.pip for pip
+# to install it. (do it after python setup.py develop and it
+# will only install this)
+
+-e git+git://leap.se/soledad@develop#egg=leap.soledad
diff --git a/mail/pkg/requirements-latest.pip b/mail/pkg/requirements-latest.pip
new file mode 100644
index 0000000..58347b6
--- /dev/null
+++ b/mail/pkg/requirements-latest.pip
@@ -0,0 +1,9 @@
+--index-url https://pypi.python.org/simple/
+
+https://launchpad.net/dirspec/stable-13-10/13.10/+download/dirspec-13.10.tar.gz
+https://launchpad.net/ubuntu/+archive/primary/+files/u1db_13.09.orig.tar.bz2
+-e 'git+https://github.com/leapcode/leap_pycommon.git@develop#egg=leap.common'
+-e 'git+https://github.com/leapcode/soledad.git@develop#egg=leap.soledad.common&subdirectory=common/'
+-e 'git+https://github.com/leapcode/soledad.git@develop#egg=leap.soledad.client&subdirectory=client/'
+-e 'git+https://github.com/leapcode/keymanager.git@develop#egg=leap.keymanager'
+-e .
diff --git a/mail/pkg/requirements-leap.pip b/mail/pkg/requirements-leap.pip
new file mode 100644
index 0000000..134b783
--- /dev/null
+++ b/mail/pkg/requirements-leap.pip
@@ -0,0 +1,3 @@
+leap.common>=0.5.1
+leap.soledad.client>=0.8.0
+leap.keymanager>=0.5.0
diff --git a/mail/pkg/requirements-testing.pip b/mail/pkg/requirements-testing.pip
new file mode 100644
index 0000000..41222f7
--- /dev/null
+++ b/mail/pkg/requirements-testing.pip
@@ -0,0 +1,7 @@
+setuptools-trial
+mock
+nose
+rednose
+nose-progressive
+coverage
+pep8>=1.1
diff --git a/mail/pkg/requirements.pip b/mail/pkg/requirements.pip
new file mode 100644
index 0000000..0caa66b
--- /dev/null
+++ b/mail/pkg/requirements.pip
@@ -0,0 +1,4 @@
+zope.interface
+twisted # >= 12.0.3 ??
+zope.proxy
+service-identity
diff --git a/mail/pkg/tools/get_authors.sh b/mail/pkg/tools/get_authors.sh
new file mode 100755
index 0000000..0169bb1
--- /dev/null
+++ b/mail/pkg/tools/get_authors.sh
@@ -0,0 +1,2 @@
+#!/bin/sh
+git log --format='%aN <%aE>' | awk '{arr[$0]++} END{for (i in arr){print arr[i], i;}}' | sort -rn | cut -d' ' -f2-
diff --git a/mail/pkg/tools/with_venvwrapper.sh b/mail/pkg/tools/with_venvwrapper.sh
new file mode 100755
index 0000000..693c0ac
--- /dev/null
+++ b/mail/pkg/tools/with_venvwrapper.sh
@@ -0,0 +1,16 @@
+#!/bin/bash
+
+#Wraps a command in a virtualenwrapper passed as first argument.
+#Example:
+#with_virtualenvwrapper.sh leap-bitmask ./run_tests.sh
+
+wd=`pwd`
+alias pyver='python -c "import $1;print $1.__path__[0]; print $1.__version__;"'
+
+source `which virtualenvwrapper.sh`
+echo "Activating virtualenv " $1
+echo "------------------------------------"
+workon $1
+cd $wd
+echo "running version: " `pyver leap.bitmask`
+$2 $3 $4 $5
diff --git a/mail/pkg/utils.py b/mail/pkg/utils.py
new file mode 100644
index 0000000..d168010
--- /dev/null
+++ b/mail/pkg/utils.py
@@ -0,0 +1,101 @@
+# -*- coding: utf-8 -*-
+# utils.py
+# Copyright (C) 2013 LEAP
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+"""
+Utils to help in the setup process
+"""
+import os
+import re
+import sys
+
+
+def is_develop_mode():
+ """
+ Returns True if we're calling the setup script using the argument for
+ setuptools development mode.
+
+ This avoids messing up with dependency pinning and order, the
+ responsibility of installing the leap dependencies is left to the
+ developer.
+ """
+ args = sys.argv
+ devflags = "setup.py", "develop"
+ if (args[0], args[1]) == devflags:
+ return True
+ return False
+
+
+def get_reqs_from_files(reqfiles):
+ """
+ Returns the contents of the top requirement file listed as a
+ string list with the lines.
+
+ @param reqfiles: requirement files to parse
+ @type reqfiles: list of str
+ """
+ for reqfile in reqfiles:
+ if os.path.isfile(reqfile):
+ return open(reqfile, 'r').read().split('\n')
+
+
+def parse_requirements(reqfiles=['requirements.txt',
+ 'requirements.pip',
+ 'pkg/requirements.pip']):
+ """
+ Parses the requirement files provided.
+
+ The passed reqfiles list is a list of possible locations to try, the
+ function will return the contents of the first path found.
+
+ Checks the value of LEAP_VENV_SKIP_PYSIDE to see if it should
+ return PySide as a dep or not. Don't set, or set to 0 if you want
+ to install it through pip.
+
+ @param reqfiles: requirement files to parse
+ @type reqfiles: list of str
+ """
+
+ requirements = []
+ skip_pyside = os.getenv("LEAP_VENV_SKIP_PYSIDE", "0") != "0"
+ for line in get_reqs_from_files(reqfiles):
+ # -e git://foo.bar/baz/master#egg=foobar
+ if re.match(r'\s*-e\s+', line):
+ pass
+ # do not try to do anything with externals on vcs
+ # requirements.append(re.sub(r'\s*-e\s+.*#egg=(.*)$', r'\1',
+ # line))
+ # http://foo.bar/baz/foobar/zipball/master#egg=foobar
+ elif re.match(r'\s*https?:', line):
+ requirements.append(re.sub(r'\s*https?:.*#egg=(.*)$', r'\1',
+ line))
+ # -f lines are for index locations, and don't get used here
+ elif re.match(r'\s*-f\s+', line):
+ pass
+
+ # argparse is part of the standard library starting with 2.7
+ # adding it to the requirements list screws distro installs
+ elif line == 'argparse' and sys.version_info >= (2, 7):
+ pass
+ elif line == 'PySide' and skip_pyside:
+ pass
+ # do not include comments
+ elif line.lstrip().startswith('#'):
+ pass
+ else:
+ if line != '':
+ requirements.append(line)
+
+ return requirements